#line 1 "..\\src\\menue_GUI.c"



 
#line 1 "..\\inc\\global.h"
 




#line 1 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"
 
 





 









#line 25 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"







 

     

     
typedef   signed          char int8_t;
typedef   signed short     int int16_t;
typedef   signed           int int32_t;
typedef   signed       __int64 int64_t;

     
typedef unsigned          char uint8_t;
typedef unsigned short     int uint16_t;
typedef unsigned           int uint32_t;
typedef unsigned       __int64 uint64_t;

     

     
     
typedef   signed          char int_least8_t;
typedef   signed short     int int_least16_t;
typedef   signed           int int_least32_t;
typedef   signed       __int64 int_least64_t;

     
typedef unsigned          char uint_least8_t;
typedef unsigned short     int uint_least16_t;
typedef unsigned           int uint_least32_t;
typedef unsigned       __int64 uint_least64_t;

     

     
typedef   signed           int int_fast8_t;
typedef   signed           int int_fast16_t;
typedef   signed           int int_fast32_t;
typedef   signed       __int64 int_fast64_t;

     
typedef unsigned           int uint_fast8_t;
typedef unsigned           int uint_fast16_t;
typedef unsigned           int uint_fast32_t;
typedef unsigned       __int64 uint_fast64_t;

     
typedef   signed           int intptr_t;
typedef unsigned           int uintptr_t;

     
typedef   signed       __int64 intmax_t;
typedef unsigned       __int64 uintmax_t;




     

     





     





     





     

     





     





     





     

     





     





     





     

     


     


     


     

     


     


     


     

     



     



     


     
    
 



#line 196 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"

     







     










     











#line 260 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"



 


#line 7 "..\\inc\\global.h"
 




















 

#line 38 "..\\inc\\global.h"
		



#line 54 "..\\inc\\global.h"


#line 62 "..\\inc\\global.h"




		


static uint32_t u32MaxByteSize =  0x007A1200; 












static struct Textinfo
{
	uint8_t size;
	uint8_t Text[256]; 
}sText;


static struct Numberinfo
{
	uint8_t size;
	uint8_t Text[10]; 
}sNumber;

#line 6 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\menue_GUI.h"
 




 
 
 

#line 11 "..\\inc\\menue_GUI.h"


 
 
 







 
 
 




 
 
 

void GUIUserCommandsFromPC (void);
void GUIUserCommandsForTestSinus (void);
void GUIWillSendAudioFileSDOK (void);
void GUIWillSendAudioFileSDNotOK (void);
void GUIWillSendNewSamplingfrequenz (void);
void GUIWillSendNewQuantisationSteps (void);
void GUIEraseAllStart(void);
void GUIEraseAllFinish(void);
void GUIInfoPage(void);
void GUIInfoPage (void);
void GUIReturnOneTitel(uint8_t Titel);
void GUIReturnAllTitels(void);
uint8_t GUIGetUserTitelWish(void);

void GUIConvertStereoToMono(uint8_t u8Titel);

void GUIReturnNoTitelOnFlash(void);
void GUIReturnTitelNotOnFlash(void);

void GUIBlocklengh_Not_Supported (void);

void GUIFileIsMonoConversioDontNeeded (void);
void GUIFileConverted(void);

void GUIPlayTitel(uint16_t u16Titel);

extern void SPI_FLASH_BufferWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
extern void SPI_FLASH_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
void PrepareFlashToRead (uint32_t u32ReadAddr);
extern void DeselectFlash (void);
extern uint8_t SPI_FLASH_SendByte(uint8_t byte);


void GUIFunctionNotSupported(void);
void GUISameSamplingFrequenz(void);
void GUINewSamplingFrequenzSmalerThanOrginal (void);

void GUITestTonStatus (void);
void GUITestTonOnOff (void);
void GUIConfigTestToneFrequenz(void);
void GUIConfigTestToneChangeValue(void);
void GUIConfigTestToneVolumen(void);
void GUIConfigParametricValue(void);
void GUILeaveTestMode (void);
void ClearLastCaracter (void);



#line 7 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\menue.h"












 

 




 
 
 







 
 
 
extern struct  Textinfo *Text_to_Array (char* cstring);
extern struct  Numberinfo *Hex_to_IntArray (uint32_t u32Number);

extern uint16_t Input_Ascii_to_Hex (void);


 
#line 8 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\hw_config.h"













 

 



 
 
 
#line 24 "..\\inc\\hw_config.h"
#line 1 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"













 

 



 
#line 1 "..\\inc\\usb_conf.h"













 

 



 
 
 
 
 
 

 
 
 
 





 
 
 
 
 


 
 



 
 





 
 
 
 
 
 


 
 
 
 
 
 
 
 


#line 175 "..\\inc\\usb_conf.h"


 
 
 
#line 186 "..\\inc\\usb_conf.h"



 







 
#line 22 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"

 
 






typedef signed long      s32;
typedef signed short     s16;
typedef signed char      s8;

typedef volatile signed long      vs32;
typedef volatile signed short     vs16;
typedef volatile signed char      vs8;

typedef unsigned long       u32;
typedef unsigned short      u16;
typedef unsigned char       u8;

typedef unsigned long  const    uc32;   
typedef unsigned short const    uc16;   
typedef unsigned char  const    uc8;    

typedef volatile unsigned long      vu32;
typedef volatile unsigned short     vu16;
typedef volatile unsigned char      vu8;

typedef volatile unsigned long  const    vuc32;   
typedef volatile unsigned short const    vuc16;   
typedef volatile unsigned char  const    vuc8;    


typedef enum
{
  FALSE = 0, TRUE  = !FALSE
}
bool;

typedef enum { RESET = 0, SET   = !RESET } FlagStatus, ITStatus;

typedef enum { DISABLE = 0, ENABLE  = !DISABLE} FunctionalState;

typedef enum { ERROR = 0, SUCCESS  = !ERROR} ErrorStatus;

 
 
 



 
#line 25 "..\\inc\\hw_config.h"
#line 1 "..\\inc\\usb_desc.h"













 

 



 
 
 
 
 









#line 40 "..\\inc\\usb_desc.h"



 
extern const uint8_t Virtual_Com_Port_DeviceDescriptor[18];
extern const uint8_t Virtual_Com_Port_ConfigDescriptor[67];

extern const uint8_t Virtual_Com_Port_StringLangID[4];
extern const uint8_t Virtual_Com_Port_StringVendor[38];
extern const uint8_t Virtual_Com_Port_StringProduct[50];
extern uint8_t Virtual_Com_Port_StringSerial[26];


 
#line 26 "..\\inc\\hw_config.h"

 
 
 








 
 
 





 
 
 
extern uint8_t  u8User_Buffer_Datas_From_PC0[256];
extern uint8_t  u8User_Buffer_Datas_From_PC1[256];
extern uint16_t u16Counter_Datas_From_PC0;
extern uint16_t u16Counter_Datas_From_PC1 ;
extern uint64_t u64Audio_Total_Byte_Counter;
extern uint32_t	u32Audio_Byte_Counter_Max_Value;
extern uint16_t u16Areas_Needed_For_File;
extern uint16_t u16Titel_Counter;

extern uint8_t 	u8User_Commands_From_PC;
extern uint8_t 	u8User_Sub_Commands_From_PC;
extern uint8_t 	u8User_Sub_Commands_For_Testtone;
extern uint8_t 	u8StateMaschine;
extern uint8_t	u8UserTitelNumber;
extern uint8_t	u8UserDatasForTesttone;

extern uint8_t buffer_in[64];






 
 
 
void VarInit_HW_Config (void);
void Set_System(void);
void Set_USBClock(void);
void Enter_LowPowerMode(void);
void Leave_LowPowerMode(void);
void USB_Interrupts_Config(void);
void USB_Cable_Config (FunctionalState NewState);
void USART_Config_Default(void);
bool USART_Config(void);
void USB_To_User_Buffer_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void User_Buffer_to_USB_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void Get_SerialNum(void);

void SaveRecivedDatas(void);

 


 
#line 9 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\internal_flash.h"
							  












 

 



 
 
 
#line 24 "..\\inc\\internal_flash.h"
#line 1 "..\\inc\\eeprom.h"














 

 



 
#line 1 "..\\inc\\internal_flash.h"
							  












 

 
#line 221 "..\\inc\\internal_flash.h"
 
#line 23 "..\\inc\\eeprom.h"

 
 
 







 
 
 
extern uint16_t DataVar;


 
 
 


 
 



 






 



 


 




 



 


 


 
 
 
uint16_t EE_Init(void);
uint16_t EE_ReadVariable(uint16_t VirtAddress, uint16_t* Data);
uint16_t EE_WriteVariable(uint16_t VirtAddress, uint16_t Data);

void Erase_all(void);



 
#line 25 "..\\inc\\internal_flash.h"


 
 
 







 
 
 







							 
#line 84 "..\\inc\\internal_flash.h"

 
 
 


extern uint16_t u16VirtAddVarTab[1*36];

 
 
 




















 
extern struct AudioInformations
{
	uint32_t ChunkID;		   
	uint32_t ChunkSize;		   
	uint32_t Format;		   
	uint32_t Subchunk1ID;	   
	uint32_t Subchunk1Size;	   
	uint16_t AudioFormat;	   
	uint16_t NumChannels;	   
	uint32_t SampleRate;	   
	uint32_t ByteRate;		   
	uint16_t BlockAlign;	   
	uint16_t BitsPerSample;	   
	uint32_t Subchunk2ID;	   
	uint32_t Subchunk2Size;	   
	uint32_t StartAdress;	   
	uint32_t EndAdress;		   
	uint32_t AudioStartAdress; 
	uint32_t AudioEndAdress;   
	uint32_t NumberOfSamples;  
	uint32_t AdressOfLastFile; 
	uint32_t AdressOfNextFile; 
}Titels[1];  



 
 
 
void set_ChunkID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ChunkID (uint8_t Number);

void set_ChunkSize (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ChunkSize (uint8_t Number);

void set_Format (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Format (uint8_t Number);

void set_Subchunk1ID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk1ID (uint8_t Number);

void set_Subchunk1Size (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk1Size (uint8_t Number);

void set_AudioFormat (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_AudioFormat (uint8_t Number);

void set_NumChannels (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_NumChannels (uint8_t Number);

void set_SampleRate (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_SampleRate (uint8_t Number);

void set_ByteRate (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ByteRate (uint8_t Number);

void set_BlockAlign (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_BlockAlign (uint8_t Number);

void set_BitsPerSample (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_BitsPerSample (uint8_t Number);

void set_Subchunk2ID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk2ID (uint8_t Number);

void set_Subchunk2Size (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk2Size (uint8_t Number);

void set_StartAdress (uint8_t Number);
uint32_t get_StartAdress (uint8_t Number);

void set_EndAdress (uint8_t Number);
uint32_t get_EndAdress (uint8_t Number);

void set_AudioStartAdress (uint8_t Number);
uint32_t get_AudioStartAdress (uint8_t Number);

void set_AudioEndAdress (uint8_t Number);
uint32_t get_AudioEndAdress (uint8_t Number);

void set_NumberOfSamples (uint8_t Number);
uint32_t get_NumberOfSamples (uint8_t Number);

void set_AdressOfLastFile(uint8_t Number);
uint32_t get_AdressOfLastFile(uint8_t Number);

void set_AdressOfNextFile(uint8_t Number);
uint32_t get_AdressOfNextFile(uint8_t Number);

void StrucktSetCurrent (uint8_t Number, uint8_t *pt_Audio_Datas);
void StrucktClearAll (void);

void init_PageTabel (void);

uint8_t get_EEPROMNumberOfTitels(void);
void set_EEPROMNumberOfTitels (uint8_t Number);

void CopyStrucktToEEPROM (uint8_t Number);
void CopyEEPROMToStruckt (uint8_t Number);

void CopyStruck (uint8_t NumberOldStruckt, uint8_t NumberNewStruckt);
void ResetAdressDatas (uint8_t NumberNewStruckt);



 
#line 10 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\dsp.h"
 




 
 
 
#line 1 "..\\inc\\stream.h"
 





























#line 10 "..\\inc\\dsp.h"
#line 11 "..\\inc\\dsp.h"

 
 
 






 
 
 

































 
 
 
extern uint8_t u8EngoingStatus;
extern uint16_t u16EngoingSinusFrequenz;
extern uint8_t u8EngoingFixSampling0OrQuantisation;
extern uint16_t u16EngoingFixValue;
extern uint16_t u16EngoingLevelInPercent;

 
 
 
extern uint16_t 		u16Titel_Counter;
void DSPConvertStereoToMono(uint8_t u8Titel);
void Sinus (uint16_t u16SinusFrequenz, uint16_t u16FixSampling0OrQuantisation, uint16_t u16FixValue, uint8_t u8LevelInPercent);
void InitTesttone (void);
void DSPPlayTitel(uint8_t u8Titel);
#line 11 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\dma_user.h"



 
 
 
#line 8 "..\\inc\\dma_user.h"
#line 9 "..\\inc\\dma_user.h"

 
 
 







 
 
 


	 

 
 
 
extern uint8_t u8DoubleBufferDSPControl;

extern uint16_t u16DoubleBuffer1[0x100];
extern uint16_t u16DoubleBuffer2[0x100];
extern uint16_t u16MasterOutBuffer[0x100*2];
extern uint16_t u16MasterBufferDataSize;

extern uint16_t u16BytesToTransferPerDMACycle;
extern uint32_t u32JumpAdressDuringBufferChanging;

extern uint8_t  u8DoubleBufferCommunicationControl;

extern uint16_t u16CountOfModifideDatasBuffer1;
extern uint16_t u16CountOfModifideDatasBuffer2;

extern float 	fQuantisationTime;
extern float 	fSkalierungsfaktorXAchse;

extern uint32_t u32CounterOfDMAStreamedDatas;

 
 
 
 
void init_DMA (void);
void DMAVarInit (void);
void RCC_Configuration_DMA(void);
void NVIC_Configuration_DMA(void);
void StartDMATransferToBuffer (uint16_t Titel);
void CopyDoubleBufferToTimerBuffer (void);
void DMA1_Channel2_IRQHandler (void);
void StartDMATransferToSpeaker (uint16_t u16Stepwide);
void StopDMATransferToSpeaker (void);



#line 12 "..\\src\\menue_GUI.c"
#line 1 "..\\inc\\usb_endp.h"













 

 



 
 
 
#line 24 "..\\inc\\usb_endp.h"
#line 25 "..\\inc\\usb_endp.h"
#line 26 "..\\inc\\usb_endp.h"

 
 
 








 
 
 


 
 
 
extern uint8_t u8Buffer_Out[64];
extern volatile uint32_t u32Count_Out;
extern uint32_t count_in;

extern uint8_t u8BufferControl;
extern uint8_t u8BufferFilled;
extern uint8_t u8EndOfFile;



 
 
 
void VarInit_USBEndp (void);

 


 
#line 13 "..\\src\\menue_GUI.c"

#pragma O3

extern const uint16_t u16DMABuffer [256];


extern uint32_t 		u32Pages;



struct Textinfo    *sTextTemp;
struct Numberinfo  *sNumberTemp;

uint16_t 		u16Transfered_Datas = 256;
uint8_t 		u8TB[256];

void GUIUserCommandsFromPC (void)
{
	 sTextTemp = Text_to_Array("Soundmodul \n\rE.G.O.\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("Druecken sie die:\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[0] um ein Soundfile aufzuspielen \n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[1] um die Samplingfrequenz zu aendern\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[2] um die Anzahl der Quantisierungsstufen zu aendern\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[3] um alles zurueckzusetzen\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[4] um Informationen ueber das Speichermedium zu erhalten\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[5] um einen bestimmten Titel zu transferieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[6] um alle Titel zu transferieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[7] um einen Stereotitel in Mono zu konvertieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[8] um einen Titel abzuspielen\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[9] um in das Testmenue zu wechseln\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8User_Commands_From_PC = 0x00;
	 u8StateMaschine = 2;
}
	
void GUIUserCommandsForTestSinus (void)
{
	sTextTemp = Text_to_Array("\n\r \n\r \n\rDruecken sie die:\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[0] um den Status des Testtons abzufufen \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[1] um den Testton zu aktivieren \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[2] um die Frequenz des Testtons zu aendern \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	sTextTemp = Text_to_Array("[3] um die Samplingfrequenz / Quantisierung zu anendern \n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[4] um die Lautstaerke zu aendern \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[5] um die Testumgebung zu verlassen \n\r \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	
	u8StateMaschine = 3;		 
}


void GUIWillSendAudioFileSDOK (void)
{
	 
	 sTextTemp = Text_to_Array("\n\rBitte Audiodatei kopieren\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
				
	 u8StateMaschine = 4;
	 u8User_Sub_Commands_From_PC = 0x00;
	 u64Audio_Total_Byte_Counter = 0;
	 u16Areas_Needed_For_File = 0;
	 u16Counter_Datas_From_PC0 = 0x0000;
	 u16Counter_Datas_From_PC1 = 0x0000;
}


void GUIWillSendAudioFileSDNotOK (void)
{
	 sTextTemp = Text_to_Array("\n\r!!!Flash Error!!!\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}


void GUIWillSendNewSamplingfrequenz (void)
{
	
	 
	 sTextTemp = Text_to_Array("\n\rDie alte Samplingfrequenz betraegt\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = 0;
	 u8User_Sub_Commands_From_PC = 0x00;
}


void GUIWillSendNewQuantisationSteps (void)
{
	
	 sTextTemp = Text_to_Array("\n\rDie neue Samplingfrequenz betraegt\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = 0;
	 u8User_Sub_Commands_From_PC = 0x00;	
}


void GUIEraseAllStart(void)
{
	 sTextTemp = Text_to_Array("\n\rBeginne Loeschvorgang\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}

void GUIEraseAllFinish (void)
{
	 sTextTemp = Text_to_Array("\n\rDaten und Einstellungen geloescht\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = 0;
	 u8User_Sub_Commands_From_PC = 0x00;
}

void GUIInfoPage (void)
{
	uint16_t u16Titelvar = 0x00;
	uint32_t u32usedMemory = 0x00;



	 sTextTemp = Text_to_Array("\n\rGesammtspeichervollumen:	");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	 sNumberTemp = Hex_to_IntArray(u32MaxByteSize);
	 User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	 sTextTemp = Text_to_Array(" Byte");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);




	for(u16Titelvar = 0x00 ; u16Titelvar < u16Titel_Counter ; u16Titelvar++)
	{
	 	u32usedMemory = u32usedMemory + get_EndAdress(u16Titelvar) - get_StartAdress(u16Titelvar);
	}

	sTextTemp = Text_to_Array("\n\rVerbruachter Speicher:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u32usedMemory);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Byte");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);




	sTextTemp = Text_to_Array("\n\rRestspeicher:			");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u32MaxByteSize-u32usedMemory);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Byte");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);



	sTextTemp = Text_to_Array("\n\r\n\rEs befinden sich ");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u16Titel_Counter);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Titel auf dem Datentraeger.");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);





    for(u16Titelvar = 0x00 ; u16Titelvar < u16Titel_Counter ; u16Titelvar++)
	{
	 	sTextTemp = Text_to_Array("\n\r\n\rTitel	Startadesse	Endadresse	Speicherbedarf	Mono\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		
		sNumberTemp = Hex_to_IntArray(u16Titelvar+1);
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("	");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		
		sNumberTemp = Hex_to_IntArray(get_StartAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		
		sNumberTemp = Hex_to_IntArray(get_EndAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		
		sNumberTemp = Hex_to_IntArray(get_EndAdress(u16Titelvar)-get_StartAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		
		if(get_NumChannels(u16Titelvar) == 1)
		{
			sTextTemp = Text_to_Array("Ja\n\r");
		}
		else
		{
			sTextTemp = Text_to_Array("Nein\n\r");
		}
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}


	 u8StateMaschine = 0;
	 u8User_Sub_Commands_From_PC = 0x00;
}

void GUIReturnNoTitelOnFlash(void)
{
	sTextTemp = Text_to_Array("\n\rEs befindet sich kein Titel auf dem Datentraeger!\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;	
}

void GUIReturnTitelNotOnFlash(void)
{
 	sTextTemp = Text_to_Array("\n\rDieser Titel befindet sich nicht auf dem Datentraeger!\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;	
}

void GUIReturnOneTitel (uint8_t u8Titel)
{
	if(u16Titel_Counter >0 && u8Titel <= u16Titel_Counter && u8Titel != 0)
	{ 
		uint32_t u32Laufvar = 0;
		uint32_t u32Lauflaenge = get_EndAdress((u8Titel-1))-get_StartAdress((u8Titel-1));
		uint32_t u32ReadAddr = get_StartAdress((u8Titel-1));
		uint8_t u8Temp;
	
		PrepareFlashToRead(u32ReadAddr);
			  
		for(u32Laufvar = 0 ; u32Laufvar < u32Lauflaenge ; u32Laufvar++)
		{
			u8Temp = SPI_FLASH_SendByte(0xA5);
			User_Buffer_to_USB_Send_Data(&u8Temp, 1);
		}
	
		DeselectFlash();
	}
	else
	{
		GUIReturnTitelNotOnFlash();
	}
	

	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;	
}

void GUIReturnAllTitels (void)
{
	uint16_t u16TitelTemp;
	for(u16TitelTemp = 1 ; u16TitelTemp <= u16Titel_Counter ; u16TitelTemp++)
	{
		uint32_t u32Laufvar = 0;
		uint32_t u32Lauflaenge = get_EndAdress((u16TitelTemp-1))-get_StartAdress((u16TitelTemp-1));
		uint32_t u32ReadAddr = get_StartAdress((u16TitelTemp-1));
		uint8_t u8Temp;
	
		PrepareFlashToRead(u32ReadAddr);
			  
		for(u32Laufvar = 0 ; u32Laufvar < u32Lauflaenge ; u32Laufvar++)
		{
			u8Temp = SPI_FLASH_SendByte(0xA5);
			User_Buffer_to_USB_Send_Data(&u8Temp, 1);
		}
	
		DeselectFlash();
	}
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;	
}

uint8_t GUIGetUserTitelWish(void)
{
	uint8_t u8temp;	
	u8StateMaschine = 7;
	u8User_Commands_From_PC = 0x00;
	sTextTemp = Text_to_Array("\n\rBitte geben sie dien Nummer des gewuenschten Titels ein: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	while(u32Count_Out == 0); 
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8temp = u8Buffer_Out[0];
	u8temp =  u8temp-0x30;
    u32Count_Out = 0;		
 	return 	u8temp;
}

void GUILeaveTestMode (void)
{
	u8StateMaschine = 2;
	InitTesttone();
	GUIUserCommandsFromPC();
}

void GUITestTonOnOff (void)
{
	u8User_Commands_From_PC = 0x00;
	u8EngoingStatus = ~u8EngoingStatus;
	
	if(u8EngoingStatus == 0)
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist an\n\r");
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist aus\n\r");
		StopDMATransferToSpeaker();		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);		
}

void GUITestTonStatus (void)
{
	u8User_Commands_From_PC = 0x00;
	if(u8EngoingStatus == 0)
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist aus\n\r");		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist an\n\r");		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	if(u8EngoingFixSampling0OrQuantisation == 0)
	{
		sTextTemp = Text_to_Array("\n\rDie Samplingfrequenz wird vom Nutzer festgelegt\n\r");		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rDie Quantisierung wird vom Nutzer festgelegt\n\r");		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	sTextTemp = Text_to_Array("\n\rDie Sinusfrequenz betraegt:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	sNumberTemp = Hex_to_IntArray(u16EngoingSinusFrequenz);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Hz");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	if(u8EngoingFixSampling0OrQuantisation == 0)
	{
		sTextTemp = Text_to_Array("\n\rDie Samplingfrequenz betraegt:		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rDie Die Quantisierung betraegt:		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	
	sNumberTemp = Hex_to_IntArray(u16EngoingFixValue);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Hz");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sTextTemp = Text_to_Array("\n\rDie Die Lautstaerke betraegt:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		  
	sNumberTemp = Hex_to_IntArray(u16EngoingLevelInPercent);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Prozent der Maximallautstaerke\n\r\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}	



void GUIConfigTestToneFrequenz(void)
{
	uint16_t u16Checkpuffer;
	u8StateMaschine = 7;
	u8User_Commands_From_PC = 0x00;
	sTextTemp = Text_to_Array("\n\rBitte geben sie die gewuenschte Frequenz des Sinustons ein: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u16Checkpuffer = Input_Ascii_to_Hex();
	
	
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
			
 	u16EngoingSinusFrequenz = u16Checkpuffer;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigTestToneChangeValue(void)
{
	uint16_t u16Checkpuffer;
	u8StateMaschine = 7;
	u8User_Commands_From_PC = 0x00;
	
	sTextTemp = Text_to_Array("\n\rDruecken sie die\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[0] um die Samplingfrequenz zu aendern\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[1] um die Quantisierung zu aendern\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	u16Checkpuffer = Input_Ascii_to_Hex();
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8EngoingFixSampling0OrQuantisation = u16Checkpuffer;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigTestToneVolumen(void)
{
	uint16_t u16Checkpuffer;

	u8StateMaschine = 7;
	u8User_Commands_From_PC = 0x00;

	sTextTemp = Text_to_Array("\n\rLautstaerke eingeben: \n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	u16Checkpuffer = Input_Ascii_to_Hex();

	if(u16Checkpuffer <= 0x64)
	{
		u16EngoingLevelInPercent = u16Checkpuffer;
		sTextTemp = Text_to_Array("%\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size); 
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rWert zu gross");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigParametricValue(void)
{
	uint8_t u8temp;	
	u8StateMaschine = 7;
	u8User_Commands_From_PC = 0x00;
	sTextTemp = Text_to_Array("\n\rWert eingeben: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	while(u32Count_Out == 0); 
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8temp = u8Buffer_Out[0];
	u8temp =  u8temp-0x30;
    u32Count_Out = 0;
	
	u16EngoingFixValue = u8temp;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}


void GUIConvertStereoToMono(uint8_t u8Titel)
{
	

 
	if(get_NumChannels(u8Titel-1) == 2)
	{
		sTextTemp = Text_to_Array("\n\rSounddatei wird Konvertiert\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		DSPConvertStereoToMono(u8Titel);  
	}
	

 
	else if(get_NumChannels(u8Titel-1) == 1)
	{
		sTextTemp = Text_to_Array("\n\rSounddatei bereits im Monoformat\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	

 
	else
	{
		sTextTemp = Text_to_Array("\n\rSounddatei nicht vorhanden\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}

	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;		
}

void GUIBlocklengh_Not_Supported (void)
{
	sTextTemp = Text_to_Array("\n\rBlocklaenge fehlerhaft\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;		
}

void GUIFileIsMonoConversioDontNeeded (void)
{
	sTextTemp = Text_to_Array("\n\rSounddatei ist bereits Monokompatibel\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;			
}

void GUIFileConverted(void)
{
	sTextTemp = Text_to_Array("\n\rSounddatei ist nun Monokompatibel\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
}

void GUIPlayTitel(uint16_t u16Titel)
{
	if(get_NumChannels(u16Titel-1) == 1)
	{
		if(u16Titel_Counter >= u16Titel-1)
		{
			sTextTemp = Text_to_Array("\n\rTitel wird ausgegeben\n\r");	
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		
			
			DSPPlayTitel(u16Titel-1);			

			sTextTemp = Text_to_Array("\n\rWidergabe beendet\n\r");
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		}
		else
		{
			sTextTemp = Text_to_Array("\n\rTitel nicht vorhanden\n\r");
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		}
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rBitte in MONO Datei konvertiern\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
	}
	u8StateMaschine = 0;
	u8User_Sub_Commands_From_PC = 0x00;	
}


void GUIFunctionNotSupported(void)
{
	sTextTemp = Text_to_Array("\n\rFunktion nicht verfgbar\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
}

void GUISameSamplingFrequenz(void)
{
	sTextTemp = Text_to_Array("\n\rSamplingfrequenz bereits gesetzt\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);				
}

void GUINewSamplingFrequenzSmalerThanOrginal (void)
{
	sTextTemp = Text_to_Array("\n\rSamplingfrequenz zu niedrig\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);				
}

void ClearLastCaracter (void)
{
	sTextTemp = Text_to_Array("\010 \010");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}

