/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __INIT_H
#define __INIT_H


/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/

#include "stdint.h"


/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __INIT_C
  #define LINKTYPE  
#else
  #define LINKTYPE extern
#endif // #ifdef __INIT_C

extern uint16_t 		u16Titel_Counter;



/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/

void init_all(void);


/*********************************************************************************************/
/*                              External Funktionsdeklarationen                               */
/*********************************************************************************************/

//SPI_FLASH
extern void SPI_FLASH_BufferWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
extern void SPI_FLASH_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
extern void SPI_FLASH_Init(void);
extern void SPI_FLASH_BulkErase(void);
extern void LINVarInit(void);


//USB_Init
extern void USB_Init(void);

//STM32F10x_flash
extern void FLASH_Unlock(void);

#endif  /*__INIT_H*/ 

