/* File Name          : hw_config.h
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 04/07/2010
* Description        : Hardware Configuration & Setup
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MENUE_H
#define __MENUE_H


/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __MENUE_C
  #define LINKTYPE_MENUE 
#else
  #define LINKTYPE_MENUE extern
#endif // #ifdef __MENUE_C


/*********************************************************************************************/
/*                              Strukturen                              */
/*********************************************************************************************/
LINKTYPE_MENUE struct  Textinfo *Text_to_Array (char* cstring);
LINKTYPE_MENUE struct  Numberinfo *Hex_to_IntArray (uint32_t u32Number);

LINKTYPE_MENUE uint16_t Input_Ascii_to_Hex (void);

#endif  /*__GLOBAL_H*/
/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
