#ifndef __TIMER_PWM_H
#define __TIMER_PWM_H

/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "global.h"
#include "stream.h"

/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __TIMER_PWM_C
  #define LINKTYPE_TIMER_PWM  
#else
  #define LINKTYPE_TIMER_PWM extern
#endif // #ifdef __TIMER_PWM_C


/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
void InitPWM(uint16_t u16Periode, uint16_t u16Prescaler, uint16_t u16_ClockDivision);
void RCC_Configuration_PWM(void);
void GPIO_Configuration_PWM(void);
void NVIC_Configuration_PWM(void);


#endif

