#define __MENUE_GUI_C
//GUI Applications

/* Includes ------------------------------------------------------------------*/
#include "global.h"
#include "menue_GUI.h"
#include "menue.h"
#include "hw_config.h"
#include "internal_flash.h"
#include "dsp.h"
#include "dma_user.h"
#include "usb_endp.h"

#pragma O3

extern const uint16_t u16DMABuffer [BUFFER_VALUE];


extern uint32_t 		u32Pages;



struct Textinfo    *sTextTemp;
struct Numberinfo  *sNumberTemp;

uint16_t 		u16Transfered_Datas = 256;
uint8_t 		u8TB[256];

void GUIUserCommandsFromPC (void)
{
	 sTextTemp = Text_to_Array("Soundmodul \n\rE.G.O.\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("Druecken sie die:\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[0] um ein Soundfile aufzuspielen \n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[1] um die Samplingfrequenz zu aendern\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[2] um die Anzahl der Quantisierungsstufen zu aendern\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[3] um alles zurueckzusetzen\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[4] um Informationen ueber das Speichermedium zu erhalten\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[5] um einen bestimmten Titel zu transferieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[6] um alle Titel zu transferieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[7] um einen Stereotitel in Mono zu konvertieren\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[8] um einen Titel abzuspielen\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 sTextTemp = Text_to_Array("[9] um in das Testmenue zu wechseln\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8User_Commands_From_PC = 0x00;
	 u8StateMaschine = EXCEPT_SUBCOMMANDS;
}
	
void GUIUserCommandsForTestSinus (void)
{
	sTextTemp = Text_to_Array("\n\r \n\r \n\rDruecken sie die:\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[0] um den Status des Testtons abzufufen \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[1] um den Testton zu aktivieren \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[2] um die Frequenz des Testtons zu aendern \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	sTextTemp = Text_to_Array("[3] um die Samplingfrequenz / Quantisierung zu anendern \n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[4] um die Lautstaerke zu aendern \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[5] um die Testumgebung zu verlassen \n\r \n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	
	u8StateMaschine = EXCEPT_TESTINFOS;		 
}


void GUIWillSendAudioFileSDOK (void)
{
	 //Datas recive
	 sTextTemp = Text_to_Array("\n\rBitte Audiodatei kopieren\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
				
	 u8StateMaschine = RECIVE_NEW_AUDIOFILES;
	 u8User_Sub_Commands_From_PC = ALL_DONE;
	 u64Audio_Total_Byte_Counter = 0;
	 u16Areas_Needed_For_File = 0;
	 u16Counter_Datas_From_PC0 = 0x0000;
	 u16Counter_Datas_From_PC1 = 0x0000;
}


void GUIWillSendAudioFileSDNotOK (void)
{
	 sTextTemp = Text_to_Array("\n\r!!!Flash Error!!!\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}


void GUIWillSendNewSamplingfrequenz (void)
{
	
	 //Change Samplingfrequenz
	 sTextTemp = Text_to_Array("\n\rDie alte Samplingfrequenz betraegt\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = COMMUNICATION_DETECTED;
	 u8User_Sub_Commands_From_PC = ALL_DONE;
}


void GUIWillSendNewQuantisationSteps (void)
{
	
	 sTextTemp = Text_to_Array("\n\rDie neue Samplingfrequenz betraegt\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = COMMUNICATION_DETECTED;
	 u8User_Sub_Commands_From_PC = ALL_DONE;	
}


void GUIEraseAllStart(void)
{
	 sTextTemp = Text_to_Array("\n\rBeginne Loeschvorgang\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}

void GUIEraseAllFinish (void)
{
	 sTextTemp = Text_to_Array("\n\rDaten und Einstellungen geloescht\n\r\n\r");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	 u8StateMaschine = COMMUNICATION_DETECTED;
	 u8User_Sub_Commands_From_PC = ALL_DONE;
}

void GUIInfoPage (void)
{
	uint16_t u16Titelvar = 0x00;
	uint32_t u32usedMemory = 0x00;
//------------------------------------------------------------------
//Ausgabe Gesammtspeichervollumen
//------------------------------------------------------------------
	 sTextTemp = Text_to_Array("\n\rGesammtspeichervollumen:	");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	 sNumberTemp = Hex_to_IntArray(u32MaxByteSize);//(0x007A1200);
	 User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	 sTextTemp = Text_to_Array(" Byte");
	 User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

//------------------------------------------------------------------
//Ausgabe Verbrauchtes Speichervollumen
//------------------------------------------------------------------
	for(u16Titelvar = 0x00 ; u16Titelvar < u16Titel_Counter ; u16Titelvar++)
	{
	 	u32usedMemory = u32usedMemory + get_EndAdress(u16Titelvar) - get_StartAdress(u16Titelvar);
	}

	sTextTemp = Text_to_Array("\n\rVerbruachter Speicher:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u32usedMemory);//(0x007A1200);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Byte");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

//------------------------------------------------------------------
//Ausgabe Restspeichervollumen
//------------------------------------------------------------------
	sTextTemp = Text_to_Array("\n\rRestspeicher:			");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u32MaxByteSize-u32usedMemory);//(0x007A1200);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Byte");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
//------------------------------------------------------------------
//Ausgabe Anzahl der Titel
//------------------------------------------------------------------
	sTextTemp = Text_to_Array("\n\r\n\rEs befinden sich ");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sNumberTemp = Hex_to_IntArray(u16Titel_Counter);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array(" Titel auf dem Datentraeger.");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
//------------------------------------------------------------------
//Info der Titel
// -Speicherbedarf
// -Anfangs - und Endadresse
//------------------------------------------------------------------
    for(u16Titelvar = 0x00 ; u16Titelvar < u16Titel_Counter ; u16Titelvar++)
	{
	 	sTextTemp = Text_to_Array("\n\r\n\rTitel	Startadesse	Endadresse	Speicherbedarf	Mono\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		//Titel
		sNumberTemp = Hex_to_IntArray(u16Titelvar+1);
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("	");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		//Start
		sNumberTemp = Hex_to_IntArray(get_StartAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		//Ende
		sNumberTemp = Hex_to_IntArray(get_EndAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		//Bedarf
		sNumberTemp = Hex_to_IntArray(get_EndAdress(u16Titelvar)-get_StartAdress(u16Titelvar));
		User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

		sTextTemp = Text_to_Array("		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		//Mono
		if(get_NumChannels(u16Titelvar) == MONO)
		{
			sTextTemp = Text_to_Array("Ja\n\r");
		}
		else
		{
			sTextTemp = Text_to_Array("Nein\n\r");
		}
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}

//------------------------------------------------------------------
	 u8StateMaschine = COMMUNICATION_DETECTED;
	 u8User_Sub_Commands_From_PC = ALL_DONE;
}

void GUIReturnNoTitelOnFlash(void)
{
	sTextTemp = Text_to_Array("\n\rEs befindet sich kein Titel auf dem Datentraeger!\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;	
}

void GUIReturnTitelNotOnFlash(void)
{
 	sTextTemp = Text_to_Array("\n\rDieser Titel befindet sich nicht auf dem Datentraeger!\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;	
}

void GUIReturnOneTitel (uint8_t u8Titel)
{
	if(u16Titel_Counter >0 && u8Titel <= u16Titel_Counter && u8Titel != 0)
	{ 
		uint32_t u32Laufvar = 0;
		uint32_t u32Lauflaenge = get_EndAdress((u8Titel-1))-get_StartAdress((u8Titel-1));
		uint32_t u32ReadAddr = get_StartAdress((u8Titel-1));
		uint8_t u8Temp;
	
		PrepareFlashToRead(u32ReadAddr);
			  
		for(u32Laufvar = 0 ; u32Laufvar < u32Lauflaenge ; u32Laufvar++)
		{
			u8Temp = SPI_FLASH_SendByte(0xA5);
			User_Buffer_to_USB_Send_Data(&u8Temp, 1);
		}
	
		DeselectFlash();
	}
	else
	{
		GUIReturnTitelNotOnFlash();
	}
	

	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;	
}

void GUIReturnAllTitels (void)
{
	uint16_t u16TitelTemp;
	for(u16TitelTemp = 1 ; u16TitelTemp <= u16Titel_Counter ; u16TitelTemp++)
	{
		uint32_t u32Laufvar = 0;
		uint32_t u32Lauflaenge = get_EndAdress((u16TitelTemp-1))-get_StartAdress((u16TitelTemp-1));
		uint32_t u32ReadAddr = get_StartAdress((u16TitelTemp-1));
		uint8_t u8Temp;
	
		PrepareFlashToRead(u32ReadAddr);
			  
		for(u32Laufvar = 0 ; u32Laufvar < u32Lauflaenge ; u32Laufvar++)
		{
			u8Temp = SPI_FLASH_SendByte(0xA5);
			User_Buffer_to_USB_Send_Data(&u8Temp, 1);
		}
	
		DeselectFlash();
	}
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;	
}

uint8_t GUIGetUserTitelWish(void)
{
	uint8_t u8temp;	
	u8StateMaschine = GET_USER_TITEL_WISH;
	u8User_Commands_From_PC = ALL_DONE;
	sTextTemp = Text_to_Array("\n\rBitte geben sie dien Nummer des gewuenschten Titels ein: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	while(u32Count_Out == 0); //Warten bis eim Zeichen empfangen wurde
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8temp = u8Buffer_Out[0];
	u8temp =  u8temp-0x30;
    u32Count_Out = 0;		
 	return 	u8temp;
}

void GUILeaveTestMode (void)
{
	u8StateMaschine = EXCEPT_SUBCOMMANDS;
	InitTesttone();
	GUIUserCommandsFromPC();
}

void GUITestTonOnOff (void)
{
	u8User_Commands_From_PC = ALL_DONE;
	u8EngoingStatus = ~u8EngoingStatus;
	
	if(u8EngoingStatus == 0)
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist an\n\r");
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist aus\n\r");
		StopDMATransferToSpeaker();		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);		
}

void GUITestTonStatus (void)
{
	u8User_Commands_From_PC = ALL_DONE;
	if(u8EngoingStatus == 0)
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist aus\n\r");		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rSinuston ist an\n\r");		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	if(u8EngoingFixSampling0OrQuantisation == 0)
	{
		sTextTemp = Text_to_Array("\n\rDie Samplingfrequenz wird vom Nutzer festgelegt\n\r");		
  	}
	else
	{
		sTextTemp = Text_to_Array("\n\rDie Quantisierung wird vom Nutzer festgelegt\n\r");		
	}
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	sTextTemp = Text_to_Array("\n\rDie Sinusfrequenz betraegt:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	sNumberTemp = Hex_to_IntArray(u16EngoingSinusFrequenz);//(0x007A1200);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Hz");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	if(u8EngoingFixSampling0OrQuantisation == 0)
	{
		sTextTemp = Text_to_Array("\n\rDie Samplingfrequenz betraegt:		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rDie Die Quantisierung betraegt:		");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	
	sNumberTemp = Hex_to_IntArray(u16EngoingFixValue);//(0x007A1200);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Hz");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);


	sTextTemp = Text_to_Array("\n\rDie Die Lautstaerke betraegt:		");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		  
	sNumberTemp = Hex_to_IntArray(u16EngoingLevelInPercent);//(0x007A1200);
	User_Buffer_to_USB_Send_Data(&(*sNumberTemp).Text[0], (*sNumberTemp).size);

	sTextTemp = Text_to_Array("	Prozent der Maximallautstaerke\n\r\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}	



void GUIConfigTestToneFrequenz(void)
{
	uint16_t u16Checkpuffer;
	u8StateMaschine = GET_USER_TITEL_WISH;
	u8User_Commands_From_PC = ALL_DONE;
	sTextTemp = Text_to_Array("\n\rBitte geben sie die gewuenschte Frequenz des Sinustons ein: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u16Checkpuffer = Input_Ascii_to_Hex();
	//Hier sollte noch abgefangen werden ob die Samplingfrequenz grer ist 
	//zum testen der unterabtastung wird dies aber gelassen
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
			
 	u16EngoingSinusFrequenz = u16Checkpuffer;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigTestToneChangeValue(void)
{
	uint16_t u16Checkpuffer;
	u8StateMaschine = GET_USER_TITEL_WISH;
	u8User_Commands_From_PC = ALL_DONE;
	
	sTextTemp = Text_to_Array("\n\rDruecken sie die\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[0] um die Samplingfrequenz zu aendern\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	sTextTemp = Text_to_Array("[1] um die Quantisierung zu aendern\n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	u16Checkpuffer = Input_Ascii_to_Hex();
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8EngoingFixSampling0OrQuantisation = u16Checkpuffer;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigTestToneVolumen(void)
{
	uint16_t u16Checkpuffer;

	u8StateMaschine = GET_USER_TITEL_WISH;
	u8User_Commands_From_PC = ALL_DONE;

	sTextTemp = Text_to_Array("\n\rLautstaerke eingeben: \n\r");	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

	u16Checkpuffer = Input_Ascii_to_Hex();

	if(u16Checkpuffer <= 0x64)
	{
		u16EngoingLevelInPercent = u16Checkpuffer;
		sTextTemp = Text_to_Array("%\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size); 
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rWert zu gross");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}

void GUIConfigParametricValue(void)
{
	uint8_t u8temp;	
	u8StateMaschine = GET_USER_TITEL_WISH;
	u8User_Commands_From_PC = ALL_DONE;
	sTextTemp = Text_to_Array("\n\rWert eingeben: ");
	
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	while(u32Count_Out == 0); //Warten bis eim Zeichen empfangen wurde
	
	sTextTemp = Text_to_Array("\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	
	u8temp = u8Buffer_Out[0];
	u8temp =  u8temp-0x30;
    u32Count_Out = 0;
	
	u16EngoingFixValue = u8temp;
	if(u8EngoingStatus == 0)
	{
		StopDMATransferToSpeaker();	
		Sinus (u16EngoingSinusFrequenz, u8EngoingFixSampling0OrQuantisation, u16EngoingFixValue,u16EngoingLevelInPercent);		
  	}
}


void GUIConvertStereoToMono(uint8_t u8Titel)
{
	/**********************************************************
	File ist Stereo
	**********************************************************/
	if(get_NumChannels(u8Titel-1) == STEREO)
	{
		sTextTemp = Text_to_Array("\n\rSounddatei wird Konvertiert\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);

		DSPConvertStereoToMono(u8Titel);  
	}
	/**********************************************************
	File war schon Mono
	**********************************************************/
	else if(get_NumChannels(u8Titel-1) == MONO)
	{
		sTextTemp = Text_to_Array("\n\rSounddatei bereits im Monoformat\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}
	/**********************************************************
	File nicht vorhanden
	**********************************************************/
	else
	{
		sTextTemp = Text_to_Array("\n\rSounddatei nicht vorhanden\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
	}

	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;		
}

void GUIBlocklengh_Not_Supported (void)
{
	sTextTemp = Text_to_Array("\n\rBlocklaenge fehlerhaft\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;		
}

void GUIFileIsMonoConversioDontNeeded (void)
{
	sTextTemp = Text_to_Array("\n\rSounddatei ist bereits Monokompatibel\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);	
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;			
}

void GUIFileConverted(void)
{
	sTextTemp = Text_to_Array("\n\rSounddatei ist nun Monokompatibel\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
}

void GUIPlayTitel(uint16_t u16Titel)
{
	if(get_NumChannels(u16Titel-1) == MONO)
	{
		if(u16Titel_Counter >= u16Titel-1)
		{
			sTextTemp = Text_to_Array("\n\rTitel wird ausgegeben\n\r");	
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		
			//Hier kommt die Ausgaberoutine rein
			DSPPlayTitel(u16Titel-1);			

			sTextTemp = Text_to_Array("\n\rWidergabe beendet\n\r");
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		}
		else
		{
			sTextTemp = Text_to_Array("\n\rTitel nicht vorhanden\n\r");
			User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
		}
	}
	else
	{
		sTextTemp = Text_to_Array("\n\rBitte in MONO Datei konvertiern\n\r");
		User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
	}
	u8StateMaschine = COMMUNICATION_DETECTED;
	u8User_Sub_Commands_From_PC = ALL_DONE;	
}


void GUIFunctionNotSupported(void)
{
	sTextTemp = Text_to_Array("\n\rFunktion nicht verfgbar\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);			
}

void GUISameSamplingFrequenz(void)
{
	sTextTemp = Text_to_Array("\n\rSamplingfrequenz bereits gesetzt\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);				
}

void GUINewSamplingFrequenzSmalerThanOrginal (void)
{
	sTextTemp = Text_to_Array("\n\rSamplingfrequenz zu niedrig\n\r");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);				
}

void ClearLastCaracter (void)
{
	sTextTemp = Text_to_Array("\010 \010");
	User_Buffer_to_USB_Send_Data(&(*sTextTemp).Text[0], (*sTextTemp).size);
}

#undef __MENUE_GUI_C
