#line 1 "..\\src\\init.c"

 
 
 
#line 1 "..\\inc\\global.h"
 




#line 1 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"
 
 





 









#line 25 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"







 

     

     
typedef   signed          char int8_t;
typedef   signed short     int int16_t;
typedef   signed           int int32_t;
typedef   signed       __int64 int64_t;

     
typedef unsigned          char uint8_t;
typedef unsigned short     int uint16_t;
typedef unsigned           int uint32_t;
typedef unsigned       __int64 uint64_t;

     

     
     
typedef   signed          char int_least8_t;
typedef   signed short     int int_least16_t;
typedef   signed           int int_least32_t;
typedef   signed       __int64 int_least64_t;

     
typedef unsigned          char uint_least8_t;
typedef unsigned short     int uint_least16_t;
typedef unsigned           int uint_least32_t;
typedef unsigned       __int64 uint_least64_t;

     

     
typedef   signed           int int_fast8_t;
typedef   signed           int int_fast16_t;
typedef   signed           int int_fast32_t;
typedef   signed       __int64 int_fast64_t;

     
typedef unsigned           int uint_fast8_t;
typedef unsigned           int uint_fast16_t;
typedef unsigned           int uint_fast32_t;
typedef unsigned       __int64 uint_fast64_t;

     
typedef   signed           int intptr_t;
typedef unsigned           int uintptr_t;

     
typedef   signed       __int64 intmax_t;
typedef unsigned       __int64 uintmax_t;




     

     





     





     





     

     





     





     





     

     





     





     





     

     


     


     


     

     


     


     


     

     



     



     


     
    
 



#line 196 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"

     







     










     











#line 260 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"



 


#line 7 "..\\inc\\global.h"
 




















 

#line 38 "..\\inc\\global.h"
		



#line 54 "..\\inc\\global.h"


#line 62 "..\\inc\\global.h"




		


static uint32_t u32MaxByteSize =  0x007A1200; 












static struct Textinfo
{
	uint8_t size;
	uint8_t Text[256]; 
}sText;


static struct Numberinfo
{
	uint8_t size;
	uint8_t Text[10]; 
}sNumber;

#line 6 "..\\src\\init.c"
#line 1 "..\\inc\\init.h"
 




 
 
 

#line 11 "..\\inc\\init.h"


 
 
 






extern uint16_t 		u16Titel_Counter;



 
 
 

void init_all(void);


 
 
 


extern void SPI_FLASH_BufferWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
extern void SPI_FLASH_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
extern void SPI_FLASH_Init(void);
extern void SPI_FLASH_BulkErase(void);
extern void LINVarInit(void);



extern void USB_Init(void);


extern void FLASH_Unlock(void);



#line 7 "..\\src\\init.c"
#line 1 "..\\inc\\hw_config.h"













 

 



 
 
 
#line 24 "..\\inc\\hw_config.h"
#line 1 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"













 

 



 
#line 1 "..\\inc\\usb_conf.h"













 

 



 
 
 
 
 
 

 
 
 
 





 
 
 
 
 


 
 



 
 





 
 
 
 
 
 


 
 
 
 
 
 
 
 


#line 175 "..\\inc\\usb_conf.h"


 
 
 
#line 186 "..\\inc\\usb_conf.h"



 







 
#line 22 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"

 
 






typedef signed long      s32;
typedef signed short     s16;
typedef signed char      s8;

typedef volatile signed long      vs32;
typedef volatile signed short     vs16;
typedef volatile signed char      vs8;

typedef unsigned long       u32;
typedef unsigned short      u16;
typedef unsigned char       u8;

typedef unsigned long  const    uc32;   
typedef unsigned short const    uc16;   
typedef unsigned char  const    uc8;    

typedef volatile unsigned long      vu32;
typedef volatile unsigned short     vu16;
typedef volatile unsigned char      vu8;

typedef volatile unsigned long  const    vuc32;   
typedef volatile unsigned short const    vuc16;   
typedef volatile unsigned char  const    vuc8;    


typedef enum
{
  FALSE = 0, TRUE  = !FALSE
}
bool;

typedef enum { RESET = 0, SET   = !RESET } FlagStatus, ITStatus;

typedef enum { DISABLE = 0, ENABLE  = !DISABLE} FunctionalState;

typedef enum { ERROR = 0, SUCCESS  = !ERROR} ErrorStatus;

 
 
 



 
#line 25 "..\\inc\\hw_config.h"
#line 1 "..\\inc\\usb_desc.h"













 

 



 
 
 
 
 









#line 40 "..\\inc\\usb_desc.h"



 
extern const uint8_t Virtual_Com_Port_DeviceDescriptor[18];
extern const uint8_t Virtual_Com_Port_ConfigDescriptor[67];

extern const uint8_t Virtual_Com_Port_StringLangID[4];
extern const uint8_t Virtual_Com_Port_StringVendor[38];
extern const uint8_t Virtual_Com_Port_StringProduct[50];
extern uint8_t Virtual_Com_Port_StringSerial[26];


 
#line 26 "..\\inc\\hw_config.h"

 
 
 








 
 
 





 
 
 
extern uint8_t  u8User_Buffer_Datas_From_PC0[256];
extern uint8_t  u8User_Buffer_Datas_From_PC1[256];
extern uint16_t u16Counter_Datas_From_PC0;
extern uint16_t u16Counter_Datas_From_PC1 ;
extern uint64_t u64Audio_Total_Byte_Counter;
extern uint32_t	u32Audio_Byte_Counter_Max_Value;
extern uint16_t u16Areas_Needed_For_File;
extern uint16_t u16Titel_Counter;

extern uint8_t 	u8User_Commands_From_PC;
extern uint8_t 	u8User_Sub_Commands_From_PC;
extern uint8_t 	u8User_Sub_Commands_For_Testtone;
extern uint8_t 	u8StateMaschine;
extern uint8_t	u8UserTitelNumber;
extern uint8_t	u8UserDatasForTesttone;

extern uint8_t buffer_in[64];






 
 
 
void VarInit_HW_Config (void);
void Set_System(void);
void Set_USBClock(void);
void Enter_LowPowerMode(void);
void Leave_LowPowerMode(void);
void USB_Interrupts_Config(void);
void USB_Cable_Config (FunctionalState NewState);
void USART_Config_Default(void);
bool USART_Config(void);
void USB_To_User_Buffer_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void User_Buffer_to_USB_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void Get_SerialNum(void);

void SaveRecivedDatas(void);

 


 
#line 8 "..\\src\\init.c"
#line 1 "..\\inc\\internal_flash.h"
							  












 

 



 
 
 
#line 24 "..\\inc\\internal_flash.h"
#line 1 "..\\inc\\eeprom.h"














 

 



 
#line 1 "..\\inc\\internal_flash.h"
							  












 

 
#line 221 "..\\inc\\internal_flash.h"
 
#line 23 "..\\inc\\eeprom.h"

 
 
 







 
 
 
extern uint16_t DataVar;


 
 
 


 
 



 






 



 


 




 



 


 


 
 
 
uint16_t EE_Init(void);
uint16_t EE_ReadVariable(uint16_t VirtAddress, uint16_t* Data);
uint16_t EE_WriteVariable(uint16_t VirtAddress, uint16_t Data);

void Erase_all(void);



 
#line 25 "..\\inc\\internal_flash.h"


 
 
 







 
 
 







							 
#line 84 "..\\inc\\internal_flash.h"

 
 
 


extern uint16_t u16VirtAddVarTab[1*36];

 
 
 




















 
extern struct AudioInformations
{
	uint32_t ChunkID;		   
	uint32_t ChunkSize;		   
	uint32_t Format;		   
	uint32_t Subchunk1ID;	   
	uint32_t Subchunk1Size;	   
	uint16_t AudioFormat;	   
	uint16_t NumChannels;	   
	uint32_t SampleRate;	   
	uint32_t ByteRate;		   
	uint16_t BlockAlign;	   
	uint16_t BitsPerSample;	   
	uint32_t Subchunk2ID;	   
	uint32_t Subchunk2Size;	   
	uint32_t StartAdress;	   
	uint32_t EndAdress;		   
	uint32_t AudioStartAdress; 
	uint32_t AudioEndAdress;   
	uint32_t NumberOfSamples;  
	uint32_t AdressOfLastFile; 
	uint32_t AdressOfNextFile; 
}Titels[1];  



 
 
 
void set_ChunkID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ChunkID (uint8_t Number);

void set_ChunkSize (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ChunkSize (uint8_t Number);

void set_Format (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Format (uint8_t Number);

void set_Subchunk1ID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk1ID (uint8_t Number);

void set_Subchunk1Size (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk1Size (uint8_t Number);

void set_AudioFormat (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_AudioFormat (uint8_t Number);

void set_NumChannels (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_NumChannels (uint8_t Number);

void set_SampleRate (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_SampleRate (uint8_t Number);

void set_ByteRate (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_ByteRate (uint8_t Number);

void set_BlockAlign (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_BlockAlign (uint8_t Number);

void set_BitsPerSample (uint8_t Number, uint8_t Byte1, uint8_t Byte2);
uint16_t get_BitsPerSample (uint8_t Number);

void set_Subchunk2ID (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk2ID (uint8_t Number);

void set_Subchunk2Size (uint8_t Number, uint8_t Byte1, uint8_t Byte2, uint8_t Byte3, uint8_t Byte4);
uint32_t get_Subchunk2Size (uint8_t Number);

void set_StartAdress (uint8_t Number);
uint32_t get_StartAdress (uint8_t Number);

void set_EndAdress (uint8_t Number);
uint32_t get_EndAdress (uint8_t Number);

void set_AudioStartAdress (uint8_t Number);
uint32_t get_AudioStartAdress (uint8_t Number);

void set_AudioEndAdress (uint8_t Number);
uint32_t get_AudioEndAdress (uint8_t Number);

void set_NumberOfSamples (uint8_t Number);
uint32_t get_NumberOfSamples (uint8_t Number);

void set_AdressOfLastFile(uint8_t Number);
uint32_t get_AdressOfLastFile(uint8_t Number);

void set_AdressOfNextFile(uint8_t Number);
uint32_t get_AdressOfNextFile(uint8_t Number);

void StrucktSetCurrent (uint8_t Number, uint8_t *pt_Audio_Datas);
void StrucktClearAll (void);

void init_PageTabel (void);

uint8_t get_EEPROMNumberOfTitels(void);
void set_EEPROMNumberOfTitels (uint8_t Number);

void CopyStrucktToEEPROM (uint8_t Number);
void CopyEEPROMToStruckt (uint8_t Number);

void CopyStruck (uint8_t NumberOldStruckt, uint8_t NumberNewStruckt);
void ResetAdressDatas (uint8_t NumberNewStruckt);



 
#line 9 "..\\src\\init.c"

#line 1 "..\\inc\\timer_pwm.h"



 
 
 
#line 8 "..\\inc\\timer_pwm.h"
#line 1 "..\\inc\\stream.h"
 





























#line 9 "..\\inc\\timer_pwm.h"

 
 
 







 
 
 
void InitPWM(uint16_t u16Periode, uint16_t u16Prescaler, uint16_t u16_ClockDivision);
void RCC_Configuration_PWM(void);
void GPIO_Configuration_PWM(void);
void NVIC_Configuration_PWM(void);




#line 11 "..\\src\\init.c"
#line 1 "..\\inc\\dma_user.h"



 
 
 
#line 8 "..\\inc\\dma_user.h"
#line 9 "..\\inc\\dma_user.h"

 
 
 







 
 
 


	 

 
 
 
extern uint8_t u8DoubleBufferDSPControl;

extern uint16_t u16DoubleBuffer1[0x100];
extern uint16_t u16DoubleBuffer2[0x100];
extern uint16_t u16MasterOutBuffer[0x100*2];
extern uint16_t u16MasterBufferDataSize;

extern uint16_t u16BytesToTransferPerDMACycle;
extern uint32_t u32JumpAdressDuringBufferChanging;

extern uint8_t  u8DoubleBufferCommunicationControl;

extern uint16_t u16CountOfModifideDatasBuffer1;
extern uint16_t u16CountOfModifideDatasBuffer2;

extern float 	fQuantisationTime;
extern float 	fSkalierungsfaktorXAchse;

extern uint32_t u32CounterOfDMAStreamedDatas;

 
 
 
 
void init_DMA (void);
void DMAVarInit (void);
void RCC_Configuration_DMA(void);
void NVIC_Configuration_DMA(void);
void StartDMATransferToBuffer (uint16_t Titel);
void CopyDoubleBufferToTimerBuffer (void);
void DMA1_Channel2_IRQHandler (void);
void StartDMATransferToSpeaker (uint16_t u16Stepwide);
void StopDMATransferToSpeaker (void);



#line 12 "..\\src\\init.c"
#line 1 "..\\inc\\usb_endp.h"













 

 



 
 
 
#line 24 "..\\inc\\usb_endp.h"
#line 25 "..\\inc\\usb_endp.h"
#line 26 "..\\inc\\usb_endp.h"

 
 
 








 
 
 


 
 
 
extern uint8_t u8Buffer_Out[64];
extern volatile uint32_t u32Count_Out;
extern uint32_t count_in;

extern uint8_t u8BufferControl;
extern uint8_t u8BufferFilled;
extern uint8_t u8EndOfFile;



 
 
 
void VarInit_USBEndp (void);

 


 
#line 13 "..\\src\\init.c"
#line 1 "..\\inc\\dsp.h"
 




 
 
 
#line 10 "..\\inc\\dsp.h"
#line 11 "..\\inc\\dsp.h"

 
 
 






 
 
 

































 
 
 
extern uint8_t u8EngoingStatus;
extern uint16_t u16EngoingSinusFrequenz;
extern uint8_t u8EngoingFixSampling0OrQuantisation;
extern uint16_t u16EngoingFixValue;
extern uint16_t u16EngoingLevelInPercent;

 
 
 
extern uint16_t 		u16Titel_Counter;
void DSPConvertStereoToMono(uint8_t u8Titel);
void Sinus (uint16_t u16SinusFrequenz, uint16_t u16FixSampling0OrQuantisation, uint16_t u16FixValue, uint8_t u8LevelInPercent);
void InitTesttone (void);
void DSPPlayTitel(uint8_t u8Titel);
#line 14 "..\\src\\init.c"

#pragma O3








 

void init_all(void)
{
	VarInit_HW_Config();
	VarInit_USBEndp();
	
	DMAVarInit();

	LINVarInit();

	InitTesttone();

	
	 Set_System();
	 Set_USBClock();
	 USB_Interrupts_Config();
	 USB_Init();
	  
	 SPI_FLASH_Init();
	  
	 FLASH_Unlock();
	  
	 EE_Init();
	
	 init_PageTabel();

	u16Titel_Counter = get_EEPROMNumberOfTitels();
					
	if(u16Titel_Counter == 0xFF)  
	{
	
		Erase_all();
		SPI_FLASH_BulkErase();
		u16Titel_Counter = 0x00;
	}
	
	else
	{
		uint8_t laufer;
	
		if(u16Titel_Counter == 0x00)
		{
			CopyEEPROMToStruckt(u16Titel_Counter);	
		}
		for(laufer = 0x00 ; laufer < u16Titel_Counter ; laufer++)
		{
			CopyEEPROMToStruckt(laufer);
		} 
	}	
}

#pragma O3

