#line 1 "..\\src\\menue.c"


#line 1 "..\\inc\\global.h"
 




#line 1 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"
 
 





 









#line 25 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"







 

     

     
typedef   signed          char int8_t;
typedef   signed short     int int16_t;
typedef   signed           int int32_t;
typedef   signed       __int64 int64_t;

     
typedef unsigned          char uint8_t;
typedef unsigned short     int uint16_t;
typedef unsigned           int uint32_t;
typedef unsigned       __int64 uint64_t;

     

     
     
typedef   signed          char int_least8_t;
typedef   signed short     int int_least16_t;
typedef   signed           int int_least32_t;
typedef   signed       __int64 int_least64_t;

     
typedef unsigned          char uint_least8_t;
typedef unsigned short     int uint_least16_t;
typedef unsigned           int uint_least32_t;
typedef unsigned       __int64 uint_least64_t;

     

     
typedef   signed           int int_fast8_t;
typedef   signed           int int_fast16_t;
typedef   signed           int int_fast32_t;
typedef   signed       __int64 int_fast64_t;

     
typedef unsigned           int uint_fast8_t;
typedef unsigned           int uint_fast16_t;
typedef unsigned           int uint_fast32_t;
typedef unsigned       __int64 uint_fast64_t;

     
typedef   signed           int intptr_t;
typedef unsigned           int uintptr_t;

     
typedef   signed       __int64 intmax_t;
typedef unsigned       __int64 uintmax_t;




     

     





     





     





     

     





     





     





     

     





     





     





     

     


     


     


     

     


     


     


     

     



     



     


     
    
 



#line 196 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"

     







     










     











#line 260 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\stdint.h"



 


#line 7 "..\\inc\\global.h"
 




















 

#line 38 "..\\inc\\global.h"
		



#line 54 "..\\inc\\global.h"


#line 62 "..\\inc\\global.h"




		


static uint32_t u32MaxByteSize =  0x007A1200; 












static struct Textinfo
{
	uint8_t size;
	uint8_t Text[256]; 
}sText;


static struct Numberinfo
{
	uint8_t size;
	uint8_t Text[10]; 
}sNumber;

#line 4 "..\\src\\menue.c"
#line 1 "..\\inc\\menue.h"












 

 




 
 
 







 
 
 
 struct  Textinfo *Text_to_Array (char* cstring);
 struct  Numberinfo *Hex_to_IntArray (uint32_t u32Number);

 uint16_t Input_Ascii_to_Hex (void);


 
#line 5 "..\\src\\menue.c"
#line 1 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"




 





 












 







 






#line 47 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"

#line 61 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"

   




 















 
#line 92 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"











 





extern __softfp unsigned __ARM_dcmp4(double  , double  );
extern __softfp unsigned __ARM_fcmp4(float  , float  );
    




 

extern __declspec(__nothrow) __softfp int __ARM_fpclassifyf(float  );
extern __declspec(__nothrow) __softfp int __ARM_fpclassify(double  );
     
     

__inline __declspec(__nothrow) __softfp int __ARM_isfinitef(float __x)
{
    return (((*(unsigned *)&(__x)) >> 23) & 0xff) != 0xff;
}
__inline __declspec(__nothrow) __softfp int __ARM_isfinite(double __x)
{
    return (((*(1 + (unsigned *)&(__x))) >> 20) & 0x7ff) != 0x7ff;
}
     
     

__inline __declspec(__nothrow) __softfp int __ARM_isinff(float __x)
{
    return ((*(unsigned *)&(__x)) << 1) == 0xff000000;
}
__inline __declspec(__nothrow) __softfp int __ARM_isinf(double __x)
{
    return (((*(1 + (unsigned *)&(__x))) << 1) == 0xffe00000) && ((*(unsigned *)&(__x)) == 0);
}
     
     

__inline __declspec(__nothrow) __softfp int __ARM_islessgreaterf(float __x, float __y)
{
    unsigned __f = __ARM_fcmp4(__x, __y) >> 28;
    return (__f == 8) || (__f == 2);  
}
__inline __declspec(__nothrow) __softfp int __ARM_islessgreater(double __x, double __y)
{
    unsigned __f = __ARM_dcmp4(__x, __y) >> 28;
    return (__f == 8) || (__f == 2);  
}
    


 

__inline __declspec(__nothrow) __softfp int __ARM_isnanf(float __x)
{
    return (0x7f800000 - ((*(unsigned *)&(__x)) & 0x7fffffff)) >> 31;
}
__inline __declspec(__nothrow) __softfp int __ARM_isnan(double __x)
{
    unsigned __xf = (*(1 + (unsigned *)&(__x))) | (((*(unsigned *)&(__x)) == 0) ? 0 : 1);
    return (0x7ff00000 - (__xf & 0x7fffffff)) >> 31;
}
     
     

__inline __declspec(__nothrow) __softfp int __ARM_isnormalf(float __x)
{
    unsigned __xe = ((*(unsigned *)&(__x)) >> 23) & 0xff;
    return (__xe != 0xff) && (__xe != 0);
}
__inline __declspec(__nothrow) __softfp int __ARM_isnormal(double __x)
{
    unsigned __xe = ((*(1 + (unsigned *)&(__x))) >> 20) & 0x7ff;
    return (__xe != 0x7ff) && (__xe != 0);
}
     
     

__inline __declspec(__nothrow) __softfp int __ARM_signbitf(float __x)
{
    return (*(unsigned *)&(__x)) >> 31;
}
__inline __declspec(__nothrow) __softfp int __ARM_signbit(double __x)
{
    return (*(1 + (unsigned *)&(__x))) >> 31;
}
     
     








#line 210 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"



   
  typedef float float_t;
  typedef double double_t;











extern __declspec(__nothrow) double acos(double  );
    
    
    
extern __declspec(__nothrow) double asin(double  );
    
    
    
    

extern __declspec(__nothrow) __pure double atan(double  );
    
    

extern __declspec(__nothrow) double atan2(double  , double  );
    
    
    
    

extern __declspec(__nothrow) double cos(double  );
    
    
    
    
extern __declspec(__nothrow) double sin(double  );
    
    
    
    

extern void __use_accurate_range_reduction(void);
    
    

extern __declspec(__nothrow) double tan(double  );
    
    
    
    

extern __declspec(__nothrow) double cosh(double  );
    
    
    
    
extern __declspec(__nothrow) double sinh(double  );
    
    
    
    
    

extern __declspec(__nothrow) __pure double tanh(double  );
    
    

extern __declspec(__nothrow) double exp(double  );
    
    
    
    
    

extern __declspec(__nothrow) double frexp(double  , int *  ) __attribute__((__nonnull__(2)));
    
    
    
    
    
    

extern __declspec(__nothrow) double ldexp(double  , int  );
    
    
    
    
extern __declspec(__nothrow) double log(double  );
    
    
    
    
    
extern __declspec(__nothrow) double log10(double  );
    
    
    
extern __declspec(__nothrow) double modf(double  , double *  ) __attribute__((__nonnull__(2)));
    
    
    
    

extern __declspec(__nothrow) double pow(double  , double  );
    
    
    
    
    
    
extern __declspec(__nothrow) double sqrt(double  );
    
    
    
#line 340 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"
    __inline double _sqrt(double __x) { return sqrt(__x); }
    __inline float _sqrtf(float __x) { return (float)sqrt(__x); }


extern __declspec(__nothrow) __pure double ceil(double  );
    
    
extern __declspec(__nothrow) __pure double fabs(double  );
    
    

extern __declspec(__nothrow) __pure double floor(double  );
    
    

extern __declspec(__nothrow) double fmod(double  , double  );
    
    
    
    
    

    









 



extern __declspec(__nothrow) double acosh(double  );
    

 
extern __declspec(__nothrow) double asinh(double  );
    

 
extern __declspec(__nothrow) double atanh(double  );
    

 
extern __declspec(__nothrow) double cbrt(double  );
    

 
__inline __declspec(__nothrow) __pure double copysign(double __x, double __y)
    

 
{
    (*(1 + (unsigned *)&(__x))) = ((*(1 + (unsigned *)&(__x))) & 0x7fffffff) | ((*(1 + (unsigned *)&(__y))) & 0x80000000);
    return __x;
}
__inline __declspec(__nothrow) __pure float copysignf(float __x, float __y)
    

 
{
    (*(unsigned *)&(__x)) = ((*(unsigned *)&(__x)) & 0x7fffffff) | ((*(unsigned *)&(__y)) & 0x80000000);
    return __x;
}
extern __declspec(__nothrow) double erf(double  );
    

 
extern __declspec(__nothrow) double erfc(double  );
    

 
extern __declspec(__nothrow) double expm1(double  );
    

 



    

 






#line 440 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"


extern __declspec(__nothrow) double hypot(double  , double  );
    




 
extern __declspec(__nothrow) __pure int ilogb(double  );
    

 
extern __declspec(__nothrow) __pure int ilogbf(float  );
    

 
extern __declspec(__nothrow) __pure int ilogbl(long double  );
    

 







    

 





    



 





    



 





    

 





    



 





    



 





    



 





    

 





    

 





    


 

extern __declspec(__nothrow) double lgamma (double  );
    


 
extern __declspec(__nothrow) double log1p(double  );
    

 
extern __declspec(__nothrow) __pure double logb(double  );
    

 
extern __declspec(__nothrow) __pure float logbf(float  );
    

 
extern __declspec(__nothrow) __pure long double logbl(long double  );
    

 
extern __declspec(__nothrow) __pure double nextafter(double  , double  );
    


 
extern __declspec(__nothrow) __pure float nextafterf(float  , float  );
    


 
extern __declspec(__nothrow) __pure long double nextafterl(long double  , long double  );
    


 
extern __declspec(__nothrow) __pure double nexttoward(double  , long double  );
    


 
extern __declspec(__nothrow) __pure float nexttowardf(float  , long double  );
    


 
extern __declspec(__nothrow) __pure long double nexttowardl(long double  , long double  );
    


 
extern __declspec(__nothrow) __pure double remainder(double  , double  );
    

 
extern __declspec(__nothrow) __pure double rint(double  );
    

 
extern __declspec(__nothrow) __pure double scalbln(double  , long int  );
    

 
extern __declspec(__nothrow) __pure float scalblnf(float  , long int  );
    

 
extern __declspec(__nothrow) __pure long double scalblnl(long double  , long int  );
    

 
extern __declspec(__nothrow) __pure double scalbn(double  , int  );
    

 
extern __declspec(__nothrow) __pure float scalbnf(float  , int  );
    

 
extern __declspec(__nothrow) __pure long double scalbnl(long double  , int  );
    

 




    

 



 
extern __declspec(__nothrow) __pure float _fabsf(float);  
__inline __declspec(__nothrow) __pure float fabsf(float __f) { return _fabsf(__f); }
extern __declspec(__nothrow) float sinf(float  );
extern __declspec(__nothrow) float cosf(float  );
extern __declspec(__nothrow) float tanf(float  );
extern __declspec(__nothrow) float acosf(float  );
extern __declspec(__nothrow) float asinf(float  );
extern __declspec(__nothrow) float atanf(float  );
extern __declspec(__nothrow) float atan2f(float  , float  );
extern __declspec(__nothrow) float sinhf(float  );
extern __declspec(__nothrow) float coshf(float  );
extern __declspec(__nothrow) float tanhf(float  );
extern __declspec(__nothrow) float expf(float  );
extern __declspec(__nothrow) float logf(float  );
extern __declspec(__nothrow) float log10f(float  );
extern __declspec(__nothrow) float powf(float  , float  );
extern __declspec(__nothrow) float sqrtf(float  );
extern __declspec(__nothrow) float ldexpf(float  , int  );
extern __declspec(__nothrow) float frexpf(float  , int *  ) __attribute__((__nonnull__(2)));
extern __declspec(__nothrow) __pure float ceilf(float  );
extern __declspec(__nothrow) __pure float floorf(float  );
extern __declspec(__nothrow) float fmodf(float  , float  );
extern __declspec(__nothrow) float modff(float  , float *  ) __attribute__((__nonnull__(2)));

 
 













 
__declspec(__nothrow) long double acosl(long double );
__declspec(__nothrow) long double asinl(long double );
__declspec(__nothrow) long double atanl(long double );
__declspec(__nothrow) long double atan2l(long double , long double );
__declspec(__nothrow) long double ceill(long double );
__declspec(__nothrow) long double cosl(long double );
__declspec(__nothrow) long double coshl(long double );
__declspec(__nothrow) long double expl(long double );
__declspec(__nothrow) long double fabsl(long double );
__declspec(__nothrow) long double floorl(long double );
__declspec(__nothrow) long double fmodl(long double , long double );
__declspec(__nothrow) long double frexpl(long double , int* ) __attribute__((__nonnull__(2)));
__declspec(__nothrow) long double ldexpl(long double , int );
__declspec(__nothrow) long double logl(long double );
__declspec(__nothrow) long double log10l(long double );
__declspec(__nothrow) long double modfl(long double  , long double *  ) __attribute__((__nonnull__(2)));
__declspec(__nothrow) long double powl(long double , long double );
__declspec(__nothrow) long double sinl(long double );
__declspec(__nothrow) long double sinhl(long double );
__declspec(__nothrow) long double sqrtl(long double );
__declspec(__nothrow) long double tanl(long double );
__declspec(__nothrow) long double tanhl(long double );

#line 812 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"





#line 905 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"











#line 1107 "..\\..\\..\\..\\Vision\\ARM\\RV31\\INC\\math.h"



 
#line 6 "..\\src\\menue.c"
#line 1 "..\\inc\\usb_endp.h"













 

 



 
 
 
#line 24 "..\\inc\\usb_endp.h"
#line 1 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"













 

 



 
#line 1 "..\\inc\\usb_conf.h"













 

 



 
 
 
 
 
 

 
 
 
 





 
 
 
 
 


 
 



 
 





 
 
 
 
 
 


 
 
 
 
 
 
 
 


#line 175 "..\\inc\\usb_conf.h"


 
 
 
#line 186 "..\\inc\\usb_conf.h"



 







 
#line 22 "..\\..\\..\\Libraries\\STM32_USB-FS-Device_Driver\\inc\\usb_type.h"

 
 






typedef signed long      s32;
typedef signed short     s16;
typedef signed char      s8;

typedef volatile signed long      vs32;
typedef volatile signed short     vs16;
typedef volatile signed char      vs8;

typedef unsigned long       u32;
typedef unsigned short      u16;
typedef unsigned char       u8;

typedef unsigned long  const    uc32;   
typedef unsigned short const    uc16;   
typedef unsigned char  const    uc8;    

typedef volatile unsigned long      vu32;
typedef volatile unsigned short     vu16;
typedef volatile unsigned char      vu8;

typedef volatile unsigned long  const    vuc32;   
typedef volatile unsigned short const    vuc16;   
typedef volatile unsigned char  const    vuc8;    


typedef enum
{
  FALSE = 0, TRUE  = !FALSE
}
bool;

typedef enum { RESET = 0, SET   = !RESET } FlagStatus, ITStatus;

typedef enum { DISABLE = 0, ENABLE  = !DISABLE} FunctionalState;

typedef enum { ERROR = 0, SUCCESS  = !ERROR} ErrorStatus;

 
 
 



 
#line 25 "..\\inc\\usb_endp.h"
#line 1 "..\\inc\\usb_desc.h"













 

 



 
 
 
 
 









#line 40 "..\\inc\\usb_desc.h"



 
extern const uint8_t Virtual_Com_Port_DeviceDescriptor[18];
extern const uint8_t Virtual_Com_Port_ConfigDescriptor[67];

extern const uint8_t Virtual_Com_Port_StringLangID[4];
extern const uint8_t Virtual_Com_Port_StringVendor[38];
extern const uint8_t Virtual_Com_Port_StringProduct[50];
extern uint8_t Virtual_Com_Port_StringSerial[26];


 
#line 26 "..\\inc\\usb_endp.h"

 
 
 








 
 
 


 
 
 
extern uint8_t u8Buffer_Out[64];
extern volatile uint32_t u32Count_Out;
extern uint32_t count_in;

extern uint8_t u8BufferControl;
extern uint8_t u8BufferFilled;
extern uint8_t u8EndOfFile;



 
 
 
void VarInit_USBEndp (void);

 


 
#line 7 "..\\src\\menue.c"
#line 1 "..\\inc\\menue_GUI.h"
 




 
 
 

#line 11 "..\\inc\\menue_GUI.h"


 
 
 







 
 
 




 
 
 

void GUIUserCommandsFromPC (void);
void GUIUserCommandsForTestSinus (void);
void GUIWillSendAudioFileSDOK (void);
void GUIWillSendAudioFileSDNotOK (void);
void GUIWillSendNewSamplingfrequenz (void);
void GUIWillSendNewQuantisationSteps (void);
void GUIEraseAllStart(void);
void GUIEraseAllFinish(void);
void GUIInfoPage(void);
void GUIInfoPage (void);
void GUIReturnOneTitel(uint8_t Titel);
void GUIReturnAllTitels(void);
uint8_t GUIGetUserTitelWish(void);

void GUIConvertStereoToMono(uint8_t u8Titel);

void GUIReturnNoTitelOnFlash(void);
void GUIReturnTitelNotOnFlash(void);

void GUIBlocklengh_Not_Supported (void);

void GUIFileIsMonoConversioDontNeeded (void);
void GUIFileConverted(void);

void GUIPlayTitel(uint16_t u16Titel);

extern void SPI_FLASH_BufferWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
extern void SPI_FLASH_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
void PrepareFlashToRead (uint32_t u32ReadAddr);
extern void DeselectFlash (void);
extern uint8_t SPI_FLASH_SendByte(uint8_t byte);


void GUIFunctionNotSupported(void);
void GUISameSamplingFrequenz(void);
void GUINewSamplingFrequenzSmalerThanOrginal (void);

void GUITestTonStatus (void);
void GUITestTonOnOff (void);
void GUIConfigTestToneFrequenz(void);
void GUIConfigTestToneChangeValue(void);
void GUIConfigTestToneVolumen(void);
void GUIConfigParametricValue(void);
void GUILeaveTestMode (void);
void ClearLastCaracter (void);



#line 8 "..\\src\\menue.c"

#pragma O3










 
struct  Textinfo *Text_to_Array (char* cstring)
{
	uint16_t u16Temp;
	
	for(u16Temp = 0x00 ; u16Temp < 256 ; u16Temp++)
	{
		sText.Text[u16Temp] = 0x00;	
	}

	for(u16Temp = 0 ; cstring[u16Temp] != '\0' ; u16Temp++)
	{
		sText.Text[u16Temp] = cstring[u16Temp];			
	}
	sText.size = u16Temp+1;
	return	&sText;
}










 
struct  Numberinfo *Hex_to_IntArray (uint32_t u32Number)
{
	uint8_t u8Umkopieren;
	uint8_t u8Umdrehen;
	uint8_t u8Stelle  = 0x09;
	uint8_t u8Multiplikator = 0x00;
	uint8_t u8Freigabe = 0x00;
	const uint8_t cu8Basis = 0x0A;


	
	if(u32Number == 0)
	{
		sNumber.Text[0] = 0x00;
		sNumber.size = 0x01;
	}
	else
	{	
		
		for(u8Umkopieren = 0x00 ; u8Umkopieren <= 9 ; u8Umkopieren++)
		{
			sNumber.Text[u8Umkopieren] = 0x00;	
		}
	
	
		
		u8Umdrehen = 0;
		for(u8Stelle = 0x09 ; u8Stelle != 0xFF ; u8Stelle--)
		{
			uint32_t Abzug = pow(cu8Basis,u8Stelle);
			u8Multiplikator = 0x00;
			while(u32Number >= Abzug)
			{
				u32Number = u32Number-pow(cu8Basis,u8Stelle);
				u8Multiplikator++;
				u8Freigabe = 0xFF;	
			}
			sNumber.Text[u8Umdrehen] = u8Multiplikator;
			if(u8Freigabe!= 0x00)
			{	
				u8Umdrehen++;
			}
		}	
	
		sNumber.size = u8Umdrehen;
	}

	for(u8Umkopieren = 0x00 ; u8Umkopieren <= (sNumber.size-1) ; u8Umkopieren++)
	{
		sNumber.Text[u8Umkopieren] = sNumber.Text[u8Umkopieren]+0x30;	
	}

	return	&sNumber;	
}









 
uint16_t Input_Ascii_to_Hex (void)
{
	uint8_t u8Counter = 0;
	uint8_t u8Potenz = 0;
	uint8_t u8Umdreher = 0;
	uint8_t u16NewValue = 0;
	uint16_t u16Result = 0;
	uint8_t u8Basis = 10;
	uint8_t u8NumerArray[10];

	u8Buffer_Out[0] = 0x00;

	while(u8Buffer_Out[0] == 0x00){;} 


	while(u8Buffer_Out[0] != 0x0D)	
	{
		u16NewValue = ((u8Buffer_Out[0])-0x30);
		if(u16NewValue < 10 && u8Buffer_Out[0] != 0x0D)
		{
			if(u32Count_Out != 0 && u8Buffer_Out[0] != 0x0D)
			{
					u8NumerArray[u8Counter] = u8Buffer_Out[0]-0x30;
					u8Counter++;
					u32Count_Out = 0;
			}
		}
		else if(u8Buffer_Out[0] != 0xFF && u8Buffer_Out[0] != 0x0D)
		{
			ClearLastCaracter();
			u8Buffer_Out[0] = 0xFF;
		}				 
	}
	u8Potenz = u8Counter;
	for(u8Umdreher = 0x00 ; u8Umdreher <u8Counter ; u8Umdreher++)
	{
		u16Result = u16Result + u8NumerArray[u8Umdreher]*pow(u8Basis,u8Potenz-1);
		u8Potenz--;	
	} 


	return	u16Result;	
}


#pragma O3


