#include "global.h"
#include "init.h"
#include "hw_config.h"
#include "internal_flash.h"
//#include "usb_init.h"

void init_all(void)
{
	//Initialisierungen	
  Set_System();
  Set_USBClock();
  USB_Interrupts_Config();
  USB_Init();
  /* extern EEPROM Init */
  SPI_FLASH_Init();
  /* Unlock the Flash Program Erase controller */
  FLASH_Unlock();
  /* intern EEPROM Init */
  EE_Init();

  init_PageTabel();

  u16Titel_Counter = get_EEPROMNumberOfTitels();
				
	if(u16Titel_Counter == 0xFF)  //Wenn Titel_Counter 0x01 dann ist 1 Titel drauf !!!
	{

		Erase_all();
		SPI_FLASH_BulkErase();
		u16Titel_Counter = 0x00;
	}

	else
	{
		uint8_t laufer;

		if(u16Titel_Counter == 0x00)
		{
			CopyEEPROMToStruckt(u16Titel_Counter);	
		}
		for(laufer = 0x00 ; laufer < u16Titel_Counter ; laufer++)
		{
			CopyEEPROMToStruckt(laufer);
		} 
	}
}
